Subject: Re: [PATCH bpf-next 1/4] xdp: Support specifying expected existing program when attaching XDP

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Fri, 27 Mar 2020 12:11:15 +0100

Alexei Starovoitov <[email-masked]> writes:

> libxdp (and now renamed to libdispatcher, right Toke?)

Not yet :)

I want to get it to initial feature completeness for XDP first, then
think about generalising the dispatcher bits (which has additional
issues, such as figuring out how to manage the dispatcher programs for
different program types).

Current code is in [0], for those following along. There are two bits of
kernel support missing before I can get it to where I want it for an
initial "release": Atomic replace of the dispatcher (this series), and
the ability to attach an freplace program to more than one "parent".
I'll try to get an RFC out for the latter during the merge window, but
I'll probably need some help in figuring out how to make it safe from
the verifier PoV.

-Toke

[0] https://github.com/xdp-project/xdp-tools/tree/xdp-multi-prog